#include <stdio.h>
#include <stdlib.h>

#include <windows.h>

typedef unsigned char* STRPTR;
typedef unsigned char  UBYTE;
typedef unsigned char  FLAG;
typedef unsigned char  TEXT;
typedef unsigned short UWORD;
typedef unsigned long  ULONG;
#define DISCARD        (void)
#define EXPORT
#define MODULE         static
#define elif           else if
#define acase          break; case
#define adefault       break; default

MODULE const STRPTR opname[8] =
{ "MOVE",
  "ADD ",
  "AND ",
  "XOR ",
  "XEC ",
  "NZT ",
  "XMIT",
  "JMP "
}, regname[32] =
{ "AUX", // 0
  "R1",
  "R2",
  "R3",
  "R4",
  "R5",
  "R6",
  "IVL", // aka Left Bank Register aka R7
  "OVF", // 8
  "R11", // 9
  "R12", // 8X305 only
  "R13", // 8X305 only
  "R14", // 8X305 only
  "R15", // 8X305 only
  "R16", // 8X305 only
  "IVR", // aka Right Bank Register aka R17
  "LIV0", // 16
  "LIV1",
  "LIV2",
  "LIV3",
  "LIV4", // 20
  "LIV5",
  "LIV6",
  "LIV7",
  "RIV0", // 24
  "RIV1",
  "RIV2",
  "RIV3",
  "RIV4", // 28
  "RIV5",
  "RIV6",
  "RIV7"  // 31
};

MODULE ULONG getsize(const STRPTR filename);

int main(int argc, char** argv)
{   UBYTE  memory[16384],
           highbyte,
           lowbyte;
    FLAG   le = FALSE;
    FILE*  thefile;
    int    i,
           iar,
           wordiar,
           thesize;
    TEXT   theline[20 + 1],
           theline2[20 + 1];
    STRPTR filename = NULL;

    if (argc < 2 || argc > 3) // argc is ALWAYS at least 1!
    {   printf("Usage: %s <filename> [-l]\n", argv[0]);
        return EXIT_FAILURE;
    }

    for (i = 1; i < argc; i++)
    {   if (!stricmp(argv[i], "-l"))
        {   le = TRUE;
        } elif (!filename)
        {   filename = argv[i];
        } else
        {   printf("!Usage: %s <filename> [-l]\n", argv[0]);
            return EXIT_FAILURE;
    }   }

    thesize = (int) getsize(filename);
    if (thesize < 2 || thesize > 16384 || thesize % 2)
    {   printf("%s doesn't exist or is the wrong size!\n", filename);
        return EXIT_FAILURE;
    }
    if (!(thefile = fopen(filename, "rb")))
    {   printf("Can't open %s!\n", filename);
        return EXIT_FAILURE;
    }
    if (fread(memory, thesize, 1, thefile) != 1)
    {   fclose(thefile);
        printf("Can't read %s!\n", filename);
        return EXIT_FAILURE;
    }
    fclose(thefile);

    for (iar = 0; iar < thesize; iar += 2)
    {   if (le)
        {   highbyte = memory[iar + 1];
            lowbyte  = memory[iar    ];
        } else
        {   highbyte = memory[iar    ];
            lowbyte  = memory[iar + 1];
        }
        wordiar = iar / 2;

        if (highbyte == 0 && lowbyte == 0)
        {   sprintf(theline, "NOP");              // MOVE AUX(0),AUX ($0000)
        } elif (highbyte == 0xCA)        
        {   sprintf(theline, "XML  %d", lowbyte); // XMIT exp8,R12   ($CAxx)
        } elif (highbyte == 0xCB)        
        {   sprintf(theline, "XMR  %d", lowbyte); // XMIT exp8,R13   ($CBxx)
        } elif
        (    (highbyte & 0xE0)                  == 0xE0
         && ((highbyte & 0x1F) * 256) + lowbyte == wordiar
        )
        {   sprintf(theline, "HALT");             // JMP *
        } else
        {   sprintf
            (   theline,
                "%s ",
                opname[(highbyte & 0xE0) >> 5]
            );
            switch (highbyte & 0xE0)
            {
            case 0xE0: // JMP address
                sprintf
                (   theline2,
                    "$%X",
                    ((highbyte & 0x1F) * 256) + lowbyte
                );
            acase 0xC0: // XMIT
                if ((highbyte & 0x10) == 0x10)
                {   if ((lowbyte & 0xE0) == 0)
                    {   sprintf
                        (   theline2,
                            "%d,%s", // exp5,df (if you want an explicit length field you must use 8 instead of 0)
                            lowbyte  & 0x1F,
                            regname[highbyte & 0x1F]
                        );
                    } else
                    {   sprintf
                        (   theline2,
                            "%d,%s,%d", // exp5,df,len
                            lowbyte  & 0x1F,
                            regname[highbyte & 0x1F],
                            (lowbyte & 0xE0) >> 5
                        );
                }   }
                else
                {   if (lowbyte >= 248)
                    {   sprintf
                        (   theline2,
                            "%d,%s", // exp8,reg
                            lowbyte - 256,
                            regname[highbyte & 0x1F]
                        );
                    } else
                    {   sprintf
                        (   theline2,
                            "%d,%s", // exp8,reg
                            lowbyte,
                            regname[highbyte & 0x1F]
                        );
                }   }
            acase 0xA0: // NZT
                if ((highbyte & 0x10) == 0x10)
                {   if ((lowbyte & 0xE0) == 0)
                    {   sprintf
                        (   theline2,
                            "%s,$%X", // df,exp5 (if you want an explicit length field you must use 8 instead of 0)
                            regname[highbyte & 0x1F],
                            ((wordiar /  32) *  32) + (lowbyte & 0x1F)
                        );
                    } else
                    {   sprintf
                        (   theline2,
                            "%s,%d,$%X", // df,len,exp5
                            regname[highbyte & 0x1F],
                            (lowbyte & 0xE0) >> 5,
                            ((wordiar /  32) *  32) + (lowbyte & 0x1F)
                        );
                }   }
                else
                {   sprintf
                    (   theline2,
                        "%s,$%X", // reg,exp8
                        regname[highbyte & 0x1F],
                        ((wordiar / 256) * 256) +  lowbyte
                    );
                }
            acase 0x80: // XEC
                if ((highbyte & 0x10) == 0x10)
                {   if ((lowbyte & 0xE0) == 0)
                    {   sprintf
                        (   theline2,
                            "$%X(%s)", // exp5(df) (if you want an explicit length field you must use 8 instead of 0)
                            /* ((wordiar /  32) *  32) + */ (lowbyte & 0x1F),
                            regname[highbyte & 0x1F]
                        );
                    } else
                    {   sprintf
                        (   theline2,
                            "$%X(%s),%d", // exp5(df),len
                            /* ((wordiar /  32) *  32) + */ (lowbyte & 0x1F),
                            regname[highbyte & 0x1F],
                            (lowbyte & 0xE0) >> 5
                        );
                }   }
                else
                {   sprintf
                    (   theline2,
                        "$%X(%s)", // exp8(reg)
                        /* ((wordiar / 256) * 256) + */  lowbyte,
                        regname[highbyte & 0x1F]
                    );
                }
            adefault: // MOVE/ADD/AND/XOR ($00/$20/$40/$60)
                if // this assumes 8X305
                (   (highbyte & 0x1F) <= 15
                 && (lowbyte  & 0x1F) <= 15
                 && (lowbyte  & 0x1F) !=  8
                )
                {   if ((lowbyte & 0xE0) == 0)
                    {   sprintf
                        (   theline2,
                            "%s,%s", // s,d
                            regname[highbyte & 0x1F],
                            regname[lowbyte  & 0x1F]
                        );
                    } else
                    {   sprintf
                        (   theline2,
                            "%s(%d),%s", // s(r),d
                            regname[highbyte & 0x1F],
                            (lowbyte & 0xE0) >> 5,
                            regname[lowbyte  & 0x1F]
                        );
                }   }
                else
                {   if ((lowbyte & 0xE0) == 0)
                    {   sprintf
                        (   theline2,
                            "%s,%s", // s,d
                            regname[highbyte & 0x1F],
                            regname[lowbyte  & 0x1F]
                        );
                    } else
                    {   sprintf
                        (   theline2,
                            "%s,%d,%s", // s,len,d
                            regname[highbyte & 0x1F],
                            (lowbyte & 0xE0) >> 5,
                            regname[lowbyte  & 0x1F]
                        );
            }   }   }
            strcat(theline, theline2);
        }

        printf
        (   "        %-20s ;$%04X: %02X %02X",
            theline,
            wordiar,
            highbyte,
            lowbyte
        );
        if     (highbyte == 2 && lowbyte == 2)
        {   printf(" 8X310: Clear Interrupt"); // MOVE R2(0),R2 ($0202)
        } elif (highbyte == 3 && lowbyte == 3)
        {   printf(" 8X310: Call");            // MOVE R3(0),R3 ($0303)
        } elif (highbyte == 4 && lowbyte == 4)
        {   printf(" 8X310: Clear Mask");      // MOVE R4(0),R4 ($0404)
        } elif (highbyte == 5 && lowbyte == 5)
        {   printf(" 8X310: Set Mask");        // MOVE R5(0),R5 ($0505)
        } elif (highbyte == 6 && lowbyte == 6)
        {   printf(" 8X310: Return");          // MOVE R6(0),R6 ($0606)
        }
        printf("\n");
    }

    printf("        END\n");
    return EXIT_SUCCESS;
}

MODULE ULONG getsize(const STRPTR filename)
{   HANDLE hFile /* = NULL */ ;
    ULONG  localsize;

    hFile = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
    if (hFile == INVALID_HANDLE_VALUE)
    {   return 0;
    }
    localsize = GetFileSize(hFile, NULL);
    DISCARD CloseHandle(hFile);
    // hFile = NULL;

    if (localsize == (ULONG) -1)
    {   return 0;
    }

    return localsize;
}

